#!/usr/bin/perl

BEGIN
{
    ($dirprg, $main::SCRIPT) = $0 =~ /(.+)\/(.+)/;
    unshift(@INC, "$dirprg/../lib", "$dirprg/../../lib/");

}

use strict;
use ParamParser;
use Lucene;
use iANT::Entry;
use iANT::Cfg;
require "iANT/Utils.pl";

use MIME::Base64;
use File::Temp;

my $O_PARAM;
my @A_OUTPUT_FIELDS = ();
my @A_INDEX_FIELDS  = ();

MAIN:
{


    $O_PARAM = New ParamParser(
                               'GETOPTLONG',
                               (
                                "store_dir=s"
                                 )
                                 );
    $O_PARAM->SetUsage(my $usage = sub {&Usage();});
    $O_PARAM->AssertDefined('store_dir');
    my $store_dir = $O_PARAM->Get('store_dir');
    my $store = Lucene::Store::FSDirectory->getDirectory($store_dir, 0);

    &GetInfo(Lucene::Index::IndexReader->open($store));
    
}

sub GetInfo
{
	my ($reader) = @_;
	my $num_docs = $reader->numDocs();
=pod
 private Query computeTopTermQuery(Directory ramdir) throws Exception {
    final Map<String,Integer> frequencyMap = 
      new HashMap<String,Integer>();
    List<String> termlist = new ArrayList<String>();
    IndexReader reader = IndexReader.open(ramdir);
    TermEnum terms = reader.terms();
    while (terms.next()) {
      Term term = terms.term();
      String termText = term.text();
      int frequency = reader.docFreq(term);
      frequencyMap.put(termText, frequency);
      termlist.add(termText);
    }
    reader.close();
=cut


	print STDOUT "Index number of documents: $num_docs\n";
	my $term = new Lucene::Index::Term('product','haem');
	
	my $doc_freq = $reader->docFreq($term);
	
	print "doc_freq:$doc_freq\n";

	my @a_method = ('Terms');#,'docFreq','getCurrentVersion','getFieldNames','getIndexCommit','getTermFreqVector','getTermFreqVectors','getTermInfosIndexDivisor','getVersion','hasDeletions','hasNorms','isCurrent','isDeleted','isLocked','isOptimized','lastModified','listCommits','main','maxDoc','norms','numDeletedDocs','numDocs','setNorm','setTermInfosIndexDivisor','termDocs','termPositions','terms','terms','unlock');
	foreach my $method (@a_method)
	{
			my $res;
			print STDOUT "METHOD:$method\n";
			eval {$res = $reader->$method};
			print STDOUT "RES:$res" .$@. "\n";
			
	}

	#my $terms = $reader->terms();
	#print STDOUT "Terms: $terms\n";
	
	
}


sub Usage
{

    print STDOUT <<END;
   
Usage:

   $0 --store_dir=<directory> 
   
 Mandatory
    --store_dir :   directory where Lucene indeces are stored
                                
END
}
